<?php
# VCReviews extension for MediaWiki v1.1, John Hobbs 2007
# Based on Ratings extension, Sanford Poon 2007
# http://www.velvetcache.org/category/projects/vcreviews/
#
# <VCReviews/>
# <VCReviewsCount/>
#
# To activate the extension, include it from your LocalSettings.php
# with: include("extensions/VCReviews/VCReviews.php");
#
# You'll need a new database table:
#
#	CREATE TABLE IF NOT EXISTS `vcreviews` (
#		`userName` varchar(255) NOT NULL,
#		`pageId` int(10) unsigned NOT NULL,
#		`namespace` int(11) NOT NULL,
#		`rating` tinyint(3) unsigned NOT NULL,
#		`title` varchar(50) NULL,
#		`review` text NOT NULL,
#		`datetime` datetime NOT NULL,
#		`ipAddress` varchar(15) NOT NULL,
#		KEY `pageId` (`pageId`)
#	) ENGINE=MyISAM DEFAULT CHARSET=latin1;

if (!defined('MEDIAWIKI')) die();

// Config
$pathToScript='/wiki/extensions/VCReviews/'; //if your path is www.yoursite.com/wiki than change this to /wiki/extensions
$VCReviewsTableName = 'vcreviews';

$wgExtensionFunctions[] = "efVCReviews";
$wgExtensionCredits['parserhook'][] = array(
		'author' => 'John Hobbs',
		'description' => 'Adds combined authenticated rating and review to MediaWiki pages.',
		'name' => 'VCReviews',
		'version' => '0.22',
		'url' => 'http://www.velvetcache.org/category/projects/vcreviews'
);

// Hooks
//$wgHooks['SkinTemplateSetupPageCss'][] = array("wfVCReviewsCSS");
$wgHooks['BeforePageDisplay'][] = array("wfVCReviewsJS");

// JS Injector
function wfVCReviewsJS(&$out) {
	global $wgArticle,$pathToScript;
//	if ($wgArticle == null) return $out;
//	if ($wgArticle->getTitle()->mNamespace != 0) return  $out;

	$out->mBodytext .= '<script type="text/javascript" language="javascript">var VCPathToScript = "'.$pathToScript.'"</script>';
	$out->mBodytext.='<script type="text/javascript" language="javascript" src="'.$pathToScript.'vcreviews.js"></script>';

	return $out;

}

// Extension Function
function efVCReviews() {
    global $wgParser, $IP, $VCReviewsTableName;
    require_once ("$IP/includes/SpecialPage.php");

    class VCReview {
    	private $reviewText;
    	private $reviewUser;
    	private $reviewRating;
    	private $reviewDate;
    	private $reviewTitle;

			function VCReview ($_reviewText='', $_reviewUser='', $_reviewRating='', $_reviewDate='', $_reviewTitle='') {
				$this->reviewText = $_reviewText;
				$this->reviewUser = $_reviewUser;
				$this->reviewRating = $_reviewRating;
				$this->reviewDate = $_reviewDate;
				$this->reviewTitle = $_reviewTitle;
			}

    	function getReviewText() { return $this->reviewText; }
    	function getReviewUser() { return $this->reviewUser; }
    	function getReviewRating() { return $this->reviewRating; }
    	function getReviewDate() { return $this->reviewDate; }
    	function getReviewTitle() { return $this->reviewTitle; }

    	function setReviewText($_reviewText) { $this->reviewText = strip_tags($_reviewText); }
    	function setReviewUser($_reviewUser) { $this->reviewUser = $_reviewUser; }
    	function setReviewRating($_reviewRating) { $this->reviewRating = intval($_reviewRating); }

			// Sometimes stupid methods are fun :)
			public static function getTableName () { global $VCReviewsTableName; return $VCReviewsTableName; }
			// Set according to: http://dev.mysql.com/doc/refman/5.0/en/date-and-time-functions.html#function_date-format
			public static function getDateFormat () { return '%M %D, %Y'; }

			public static function renderStars ($total, $count = 1) {

				global $pathToScript;

				$returnMe = '';
				$floor = ($count == 0) ? 0 : floor($total/$count);
				$afterPoint = ($count == 0) ? 0 : (round($total/$count,2)-$floor)*100;
				for($j = 1; $j < 6; $j++) {
					if($j <= $floor)
						$returnMe .= '<img src="'.$pathToScript.'yellow.100.gif" alt="'.$j.' stars" />';
					else if($j == $floor+1) {
						if($afterPoint <= 10)
							$returnMe .= '<img src="'.$pathToScript.'clear.gif" alt="'.$j.' stars" />';
						else if($afterPoint <= 35)
							$returnMe .= '<img src="'.$pathToScript.'yellow.25.gif" alt="'.$j.' stars" />';
						else if ($afterPoint <= 60)
							$returnMe .= '<img src="'.$pathToScript.'yellow.50.gif" alt="'.$j.' stars" />';
						else
							$returnMe .= '<img src="'.$pathToScript.'yellow.75.gif" alt="'.$j.' stars" />';
					}
					else
						$returnMe .= '<img src="'.$pathToScript.'clear.gif" alt="'.$j.' stars" />';
				}

				return $returnMe;

			}

    }

    $wgParser->setHook("VCReviews", "efRenderVCReviews");
    $wgParser->setHook("VCReviewsCount", "efCountVCReviews");
    $wgParser->disableCache();
}

// Tag hooks
function efRenderVCReviews($input, $argv = array()) {

	global $IP, $wgParser, $wgUser, $wgScriptPath, $wgTitle, $wgRequest, $wgArticlePath, $wgOut, $pathToScript;
	$wgParser->disableCache();

	$OUT = '';
	$alreadyReviewed = false;

	$dbr = &wfGetDB(DB_SLAVE);
	$dbr->tableName(VCReview::getTableName());

	// Process new review (if needed)
	if($wgUser->isLoggedIn() && isset($_POST['VCRatingHidden']) && isset($_POST['VCReview'])) {

		// Check for dobule entries...
		$sql = "
			SELECT COUNT(*) AS count
			FROM ".VCReview::getTableName()."
			WHERE userName = '".$wgUser->mName."'
			AND pageId = '".$wgTitle->getArticleId()."'
		";
		$result = $dbr->query($sql, 'efRenderVCReviews (CHECK)');
		$row = $dbr->fetchObject($result);
		$dbr->freeResult($result);

		// Sanitize
		$_POST['VCReview'] = mysql_real_escape_string(strip_tags($_POST['VCReview']));
		$_POST['VCTitle'] = mysql_real_escape_string(strip_tags($_POST['VCTitle']));
		$_POST['VCRatingHidden'] = intval($_POST['VCRatingHidden']);

		if($row->count == 0 && $_POST['VCRatingHidden'] <= 5 && $_POST['VCRatingHidden'] >= 1) {
			$sql = "
				INSERT INTO ".VCReview::getTableName()."
					(userName, pageId, namespace, review, rating, datetime, ipAddress, title)
				VALUES
					(
						'".$wgUser->mName."', '".$wgTitle->getArticleId()."',
						'".$wgTitle->getNameSpace()."', '".$_POST['VCReview']."',
						'".$_POST['VCRatingHidden']."', NOW(),
						'".$_SERVER['REMOTE_ADDR']."', '".$_POST['VCTitle']."'
					)
			";
			$result = $dbr->query($sql, 'efRenderVCReviews (INSERT)');
		}

		$alreadyReviewed = true;
	}


	// Print out reviews
	$sql = "
		SELECT userName, review, title, rating, DATE_FORMAT(datetime, '".VCReview::getDateFormat()."') AS datetime_f
		FROM ".VCReview::getTableName()."
		WHERE pageId = '".$wgTitle->getArticleId()."'
		ORDER BY datetime DESC
	";
  $result = $dbr->query($sql, 'efRenderVCReviews (FETCH)');

  $reviewStack = array();
  $reviewCount = intval($dbr->numRows($result));
  $reviewTotal = 0;


  while ($row = $dbr->fetchObject($result)) {

  	if($row->userName == $wgUser->mName)
  		$alreadyReviewed = true;

  	array_push($reviewStack, new VCReview($row->review, $row->userName, $row->rating, $row->datetime_f, $row->title));
  	$reviewTotal += $row->rating;

  }

  $dbr->freeResult($result);

	$OUT .= '

		<div style="width: 100%; border: 1px solid #777; background: #F6F6F6; padding: 5px;">
			<table style="margin-bottom: 5px; padding: 5px; background: #FFF; border: 1px solid #000;">
				<tr>
					<td style="vertical-align: top;"><b>Average Rating:</b></td>
					<td style="text-align: center;">
						'.VCReview::renderStars($reviewTotal,$reviewCount).'<br/>
						( '.(($reviewCount != 0) ? round($reviewTotal/$reviewCount,2) : '0').' of 5 Stars )
					</td>
				</tr>
				<tr>
					<td><b>Total Reviews:</b></td>
					<td>'.$reviewCount.'</td>
				</tr>
			</table>
			<div style="padding: 5px; border: 1px solid #777; border-left: 0px; border-right: 0px;">
	';
	if($wgUser->isLoggedIn() && !$alreadyReviewed)	 {
			$OUT .= '
				<b><a href="javascript:VCflip();"><span id="flipText">Write A Review</span></a></b>
				<form action="" method="POST">
					<table style="padding: 5px; background: #FFF; border: 1px solid #000; display: none;" id="VCReviewArea">
						<tr>
							<td><b>Rating:</b></td>
							<td>
								<img id="VC1" src="'.$pathToScript.'yellow.100.gif" alt="(1)" onMouseOver="VCMOver(1);" onMouseOut="VCMOut(1);" onClick="VCRatingClick(1);" /><img id="VC2" src="'.$pathToScript.'yellow.100.gif" alt="(2)" onMouseOver="VCMOver(2);" onMouseOut="VCMOut(2);" onClick="VCRatingClick(2);" /><img id="VC3" src="'.$pathToScript.'yellow.100.gif" alt="(3)" onMouseOver="VCMOver(3);" onMouseOut="VCMOut(3);" onClick="VCRatingClick(3);" /><img id="VC4" src="'.$pathToScript.'clear.gif" alt="(4)" onMouseOver="VCMOver(4);" onMouseOut="VCMOut(4);" onClick="VCRatingClick(4);" /><img id="VC5" src="'.$pathToScript.'clear.gif" alt="(5)" onMouseOver="VCMOver(5);" onMouseOut="VCMOut(5);" onClick="VCRatingClick(5);" /></a>
								<input type="hidden" name="VCRatingHidden" id="VCRatingHidden" value="3" />
							</td>
						</tr>
						<tr>
							<td>
								<b>Title:</b>
							</td>
							<td>
								<input type="text" name="VCTitle" />
							</td>
						</tr>
						<tr>
							<td style="vertical-align: top;">
								<b>Review:</b>
							</td>
							<td style="padding-right: 10px;">
								<textarea rows="8" cols="50" name="VCReview"></textarea>
							</td>
						</tr>
						<tr>
							<td colspan="2" style="text-align: right;">
								<input type="submit" value="Submit" />
							</td>
						</tr>
					</table>
				</form>
			';
	}
	else if($alreadyReviewed) {
		$OUT .= 'You have already written a review for this page.';
	}
	else {
		$OUT .= 'You must <a href="./Special:Userlogin">login</a> to write a review.';
	}
	$OUT .= '</div>';

	foreach($reviewStack as $theReview) {
		$OUT .= '
			<table style="border: 1px solid #000; background: #FFF; margin: 5px; padding: 5px;">
				<tr>
					<td>
						<table>
							<tr><td><b>Rating:</b></td>
							<td>
								'.VCReview::renderStars($theReview->getReviewRating()).'
							</td>
							</tr>
		';
		if(trim($theReview->getReviewTitle()) != '') {
			$OUT .= '<tr><td><b>Title:</b></td><td>'.$theReview->getReviewTitle().'</td></tr>';
		}
		$OUT .= '
						<tr><td><b>User:</b><td><a href="./User:'.$theReview->getReviewUser().'">'.$theReview->getReviewUser().'</a></td></tr>
						<tr><td><b>Date:</b></td><td>'.$theReview->getReviewDate().'</td></tr>
					</table>
		';
		if(trim($theReview->getReviewText()) != '') {
			$OUT .= '
				<tr>
					<td>'.$theReview->getReviewText().'</td>
				</tr>
			';
		}
		$OUT .= '
			</table>
		';
	}

	$OUT .= '
		</div>
	';

	return $OUT;
}

function efCountVCReviews () {

	$dbr = &wfGetDB(DB_SLAVE);
	$dbr->tableName(VCReview::getTableName());

	// Check for dobule entries...
	$sql = "
		SELECT COUNT(*) AS count
		FROM ".VCReview::getTableName()."
	";
	$result = $dbr->query($sql, 'efCountVCReviews (COUNT)');
	$row = $dbr->fetchObject($result);
	$dbr->freeResult($result);

	return $row->count;

}
?>
